#!/usr/bin/perl -w

use strict;
use vars qw(%length %prereq);

while (<>)
{
  chomp;
  my @fields = split;
  my $task = shift @fields;
  $length{$task} = shift @fields;
  $prereq{$task} = \@fields;
}

die "Cycle found" if cycle('FINAL');

my ($len, @pat) = crit('FINAL');

#shift @pat;
print join "\n", reverse(@pat), "\n";

sub crit
{
  my $task = shift;

  my $max = 0;
  my @maxpat = ();
  for my $pre (@{$prereq{$task}})
  {
    my ($len, @pat) = crit($pre);
    if ($len > $max)
    {
      $max = $len;
      @maxpat = @pat;
    }
  }

  return ($max + $length{$task}),$task,@maxpat;
}

sub cycle
{
  my ($task,@seen) = @_;

  return 1 if grep /^$task$/, @seen;

  push @seen, $task;

  for my $pre (@{$prereq{$task}})
  {
    return 1 if cycle($pre, @seen);
  }

  return 0;
}


